=== modified file 'lib/canonical/launchpad/database/bug.py'
--- lib/canonical/launchpad/database/bug.py	2008-04-21 11:36:42 +0000
+++ lib/canonical/launchpad/database/bug.py	2008-04-24 07:55:26 +0000
@@ -23,6 +23,7 @@
 from sqlobject import BoolCol, IntCol, ForeignKey, StringCol
 from sqlobject import SQLMultipleJoin, SQLRelatedJoin
 from sqlobject import SQLObjectNotFound
+from storm.store import Store
 
 from canonical.launchpad.interfaces import (
     BugAttachmentType, BugTaskStatus, BugTrackerType, DistroSeriesStatus,
@@ -323,14 +324,22 @@
             if sub.person.id == person.id:
                 return sub
 
-        return BugSubscription(
+        subscription = BugSubscription(
             bug=self, person=person, subscribed_by=subscribed_by)
+        # Ensure that the subscription has been flushed.
+        subscription_id = subscription.id
+        return subscription
 
     def unsubscribe(self, person):
         """See `IBug`."""
         for sub in self.subscriptions:
             if sub.person.id == person.id:
-                BugSubscription.delete(sub.id)
+                store = Store.of(sub)
+                store.remove(sub)
+                # Make sure that the subscription removal has been
+                # flushed so that code running with implicit flushes
+                # disabled see the change.
+                store.flush()
                 return
 
     def unsubscribeFromDupes(self, person):

